/*
 * evo.h
 */

extern int popsize;					// popsize
extern long int maxevaluations;		// max number of evaluations
extern int seed;					// random seed
extern int nreplications;			// number of replications
extern double prange;				// parameters range
extern double mutrate;				// mutation rate
extern double *bestggenotype;		// vector of genes
extern int steptimelength;			// step timelength during display

extern double evaluate(double* genotype, const int glen, int mode);
extern double evaluate2(double* genotype1, double* genotype2, const int glen, int phase);
extern void createInitialStates(int mode);
extern void saveGenotype(char* filename, double* genotype, int glen);
extern int loadGenotype(char* filename, double* genotype, int glen);
extern void savePop(char* filename, double **pop, int glen, int popsize);
extern void loadPop(char* filename, double **pop, int glen, int popsize);
extern bool readEvoParameters(const char* filename);
extern void evolve(int ngenes);
extern void test(int ngenes);
