/*
 * evo.h
 */

extern long int maxevaluations;		// max number of evaluations
extern int seed;					// random seed
extern int nreplications;			// number of replications
extern double prange;				// parameters range
extern double *bestggenotype;		// vector of genes
extern int steptimelength;			// step timelength during display

extern double evaluate(double* genotype, const int glen, int mode);
extern void createInitialStates(int mode);
extern void saveGenotype(char* filename, double* genotype, int glen);
extern int loadGenotype(char* filename, double* genotype, int glen);
extern void savePop(char* filename, double **pop, int glen, int popsize);
extern void loadPop(char* filename, double **pop, int glen, int popsize);
extern bool readEvoParameters(const char* filename);
extern void evolve(int ngenes);
